//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-18 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:uart.c
//
//  M̂ݎgp
//
//  2017/10/19 New  Taishi [TAB4}
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"four_in18_clock.h"
#include	"timer.h"
#include	"uart.h"

// **********************************************************
// ************************** UART **************************
// **********************************************************

#define			NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			DATA_WARITE_POS_MASK	(NofRxdBuf - 1)
unsigned char	rxd_data[NofRxdBuf];						// Mf[^obt@
unsigned char	write_rxd_pos = 0;
unsigned char	read_rxd_pos = 0;

//***************************
// UART Initial
//***************************
void	uart_init(void)
{
	PRR &= ~(1 << PRUSART0);									// UART0 ғ
	delay_2us(100/2);											// POOr҂

	UBRR0  = BPS_600;											// aor

	UCSR0C = (V_PARITY_NON | V_DATA_8);							// peBAf[^

	UCSR0A = V_UCSR0A;
	UCSR0B = V_UCSR0B;

}
//***************************
// UART Close
//***************************
void	uart_close(void)
{
	UCSR0B = 0x00;
	PRR |= (1 << PRUSART0);										// ~
	delay_2us(100/2);											// POOr҂
}
#if	0
//***************************
// UART TxD One Char
//  荞݂gȂ
//***************************
void	uart_tx_one(unsigned char uc)
{
	while((UCSR0A & (1 << UDRE0)) == 0){
		;
	}
	UDR0 = uc;
}
//***************************
// UART TxD String
//  荞݂gȂ
//***************************
void	uart_tx_str(char *str)
{
	while(*str != 0){
		uart_tx_one((unsigned char)(*str));
		str++;
	}
}
//***************************
// UART TxD String + CR + LF
//***************************
void	uart_tx_str_crlf(char *str)
{
	uart_tx_str(str);											// UART TxD String
	uart_tx_one(0x0d);											// CR
	uart_tx_one(0x0a);											// LF
}
#endif

//***************************
// UART0 RXD Interrupt
//***************************
ISR	(USART_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
	unsigned char	wr_pos;

	er = (UCSR0A & ((1<<FE0)|(1<<DOR0)|(1<<UPE0)) );	// G[Ԏ擾
	uc = UDR0;											// Mf[^擾

	if(er == 0){										// G[
		wr_pos = write_rxd_pos;
		rxd_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd_pos){						// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd_pos = wr_pos;
		}
	}
}
//***************************
// RXD Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd_pos == read_rxd_pos){						// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd_data[read_rxd_pos];						// Mf[^obt@擾
		read_rxd_pos++;
		read_rxd_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}

